from rocolib.api.components.Component import Component
from rocolib.api.Function import Function

c = Component()

c.addSubcomponent("boat", "BoatBase", inherit=True, prefix=None)
c.inheritAllInterfaces("boat")

c.addParameter("length", 156, paramType="length")
c.addParameter("width", 90, paramType="length")
c.addParameter("depth", 70, paramType="length")

c.addConstraint(("boat", "boat.length"), "length")
c.addConstraint(("boat", "boat.width"), "width")
c.addConstraint(("boat", "boat.depth"), "depth")

c.addSubcomponent("servostack", "ServoStackMount")
c.inheritAllInterfaces("servostack")

c.addSubcomponent("batterymount", "BatteryMount")
c.inheritAllInterfaces("batterymount")
#
c.addSubcomponent("portsplit0", "SplitEdge")
c.inheritAllInterfaces("portsplit0")
c.addConstConstraint(("portsplit0", "toplength"), (156,)) #156-61
c.addConstConstraint(("portsplit0", "botlength"), (95, 61))

c.addConnection(("portsplit0", "topedge0"), ("boat", "portedge"))

c.addSubcomponent("portsplit1", "SplitEdge")
c.inheritAllInterfaces("portsplit1")
c.addConstConstraint(("portsplit1", "toplength"), (95,61)) #156-61
c.addConstConstraint(("portsplit1", "botlength"), (61, 10, 24, 61))

c.addConnection(("portsplit0", "botedge0"), ("portsplit1", "topedge0"))
c.addConnection(("portsplit0", "botedge1"), ("portsplit1", "topedge1"))

c.addConnection(("portsplit1", "botedge0"), ("servostack", "lstacksplit"))
c.addConnection(("portsplit1", "botedge2"), ("servostack", "lservosplit"))

c.addConnection(("batterymount", "leftArmInterface"), ("portsplit1", "botedge3"), tabWidth=10)

# c.addSubcomponent("starsplit", "SplitEdge")
# c.inheritAllInterfaces("starsplit")
# c.addConstConstraint(("starsplit", "toplength"), (169,))
# c.addConstConstraint(("starsplit", "botlength"), (108, 61))
#
# c.addConnection(("portsplit", "topedge0"), ("boat", "portedge")) #both face the same direction
# c.addConnection(("portsplit", "botedge1"), ("servostackbattery", "lservostackbatterysplit"))
#
# c.addConnection(("starsplit", "topedge0"), ("boat", "staredge")) #both face the same direction
# c.addConnection(("starsplit", "botedge0"), ("servostackbattery", "rservostackbatterysplit"))
#
# c.addConnection(("boat", "portedge"), ("servostack", "lservostacksplit")) #both face the same direction
# c.addConnection(("boat", "staredge"), ("servostack", "lservostacksplit"))

c.toLibrary("BoatWithServoStackBattery")
